#include<f3dGridLite.h>
#include<myImage.h>
#include <math.h>

using namespace::std;


#define Abs(x) ((x<0) ? -(x) : (x))

char *progname;

//
void usage(void)
{
	fprintf(stderr, "%s --- Volume smoothing using oriented mask\n",progname);
	fprintf(stderr,"usage: %s -i input_file -o output file\n",progname);
	exit(1);
}

typedef f3dGrid<f3dUChar> myGrid;

main(int argc, char *argv[])
{
	progname = argv[0];
	MSC_SET_BINARY;
	char *ifile=(char *)"in.f3d", *ofile=(char *)"out.f3d";

	for (--argc, ++argv; argc > 0; )
		if (strcmp(*argv,"-h") == 0 || strcmp(*argv,"--help") == 0  ) {
			usage();
		} else if (strcmp(*argv,"-v") == 0 || strcmp(*argv,"--version") == 0  ) {
			exit(1);
		} else if (strcmp(*argv,"-i") == 0) {
			ifile = (char *)*++argv;
			++argv;
			argc -= 2;
		} else if (strcmp(*argv,"-o") == 0) {
			ofile = (char *)*++argv;
			++argv;
			argc -= 2;
		} else {
			break;
		}

	int x,y,z;
	// load the data from stdin
	myGrid *in = new myGrid(ifile, f3dUCharType);
	// create output grid
	myGrid *out = new myGrid(in->getNX(), in->getNY(), in->getNZ(), f3dUCharType);

	for (z=0; z<in->getNZ(); z++) 
		for (y=0; y<in->getNY(); y++) 
			for (x=0; x<in->getNX(); x++) {
				//float val= in->getWrap(x, y, z);
				float val= in->get(x, y, z);
				// replace this line by something fancy
				out->set(x,y,z,(unsigned char)val);
		}

	//write the result to stdout
	out->save(ofile);
}
